
package org.ebmwebsourcing.b2bgw.edifact.lexers_parsers.edifact_message;   
import java_cup.runtime.*;
      
%%////////////////////////////////////////////////////////////////////////

%class LexerEDIFACT

%public
%line
%column
%16bit
%unicode

%cup
   
%{   
    private Symbol symbol(int type) {
        return new Symbol(type, yyline, yycolumn);
    }

    private Symbol  symbol(int type, Object value) {
        return new Symbol(type, yyline, yycolumn, value);
    }  
    
    private boolean segbeg = true;
    
%}		

escapechar = "?'" | "?+" | "?:"

segment = "'" 

tag = ":"

compo ="+"

other = [A-Za-z0-9_,. ]+ "é"? "è"? | [A-Za-z0-9_-/,. ]* "-"? "@"? "é"? "è"? "à"? "ç"? "-"? "("? "/"? [A-Za-z0-9_-/,. ]* ")"? | [A-Za-z0-9_-/,. ]+ "?" [A-Za-z0-9_-/,. ]+ 
/////////////////////////////////////////////////////////////////
%%
  
   
<YYINITIAL> {

	{escapechar}
		{
			if (segbeg){
    			segbeg = false;
    			return symbol(SymEDIFACT.SEGCODE, yytext());	
    		}
    		else {
	    		return symbol(SymEDIFACT.VALUE, yytext());	
	    	}
		}

	{segment}
		{
			segbeg = true;
			return symbol(SymEDIFACT.SEGMENT);
		}
		
	{compo}
		{
			return symbol(SymEDIFACT.COMPO);
		}
		
	{tag}
		{
			return symbol(SymEDIFACT.TAG);
		}				
		
	{other}
    	{
    		if (segbeg){
    			segbeg = false;
    			return symbol(SymEDIFACT.SEGCODE, yytext());	
    		}
    		else {
	    		return symbol(SymEDIFACT.VALUE, yytext());	
	    	}
    	}

    [^]                    
		{ 
    		throw new Error("Illegal character <"+yytext()+">"); 
    	}
}


