/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2005 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * Id : ${file_name} 154 ${date}  rbarraza 
 * -------------------------------------------------------------------------
 */
package org.objectweb.petals.component.common.handleMessagesExchange;

import java.util.Set;

import javax.activation.DataHandler;
import javax.jbi.JBIException;
import javax.jbi.messaging.ExchangeStatus;
import javax.jbi.messaging.Fault;
import javax.jbi.messaging.MessageExchange;
import javax.jbi.messaging.MessagingException;
import javax.jbi.messaging.NormalizedMessage;
import javax.xml.namespace.QName;
import javax.xml.transform.Source;

import org.objectweb.petals.component.common.util.SourceHelper;

/**
 * 
 * @version $Rev: 250 $Date: {date}
 * @since Petals 1.0
 * @author Rocio BARRAZA - eBMWebsourcing
 * 
 */
public class HandleResponses {

    public static void faultMessageExchange(MessageExchange messageExchange,
            Throwable thr, String code) throws JBIException {
        Fault fault;
        try {
            fault = messageExchange.createFault();

            // Create fault message.
            Source source = SourceHelper.createContentSource(SourceHelper
                    .createSoapFault(thr, code));
            fault.setContent(source);

            messageExchange.setFault(fault);
            messageExchange.setStatus(ExchangeStatus.ERROR);

        } catch (MessagingException e) {
            throw new JBIException(e.getMessage());
        }
    }

    public static void buildInMessage(MessageExchange msg, String mailCorps,
            QName service, String operation, Set<DataHandler> attach)
        throws JBIException {
        Source source = null;
        if (mailCorps != null)
            source = SourceHelper.createSource(mailCorps);
        NormalizedMessage nm;
        try {
            nm = msg.createMessage();
            if (attach != null) {
                for (DataHandler handler : attach) {
                    nm.addAttachment(handler.getName(), handler);
                }
            }

            nm.setContent(source);
            msg.setMessage(nm, "IN");
            msg.setService(service);
            if (operation != null && !operation.equals("")) {
                msg.setOperation(new QName(operation));
            }

        } catch (javax.jbi.messaging.MessagingException e) {
            throw new JBIException(e.getMessage());
        }
    }
}
