/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2005 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id: InstallationService.java 154 2006-03-27 15:30:10Z wjoseph $
 * -------------------------------------------------------------------------
 */
package org.objectweb.petals.component.common.serviceunitmanager.manager;

import javax.jbi.servicedesc.ServiceEndpoint;

import org.w3c.dom.Document;

/**
 * Interface of the PetalsServiceUnitManager for endpoint manipulation
 * 
 * @version $Rev: 250 $ $Date: 2006-04-21 14:20:57 +0200 (ven, 21 avr 2006) $
 * @since Petals 1.0
 * @author wjoseph - EBM Webousourcing
 * 
 */
public interface PetalsServiceUnitManagerEndpointHandling {

        public Document getServiceDescription(ServiceEndpoint se);

        public ServiceEndpoint getServiceUnitEndpoint(String serviceUnitName);

        public void setServiceDescription(ServiceEndpoint se,
                        Document serviceDesc);

        public void setServiceUnitEndpoint(String serviceUnitName,
                        ServiceEndpoint serviceEP);

}
