/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2006 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id: Axis2BCListener.java 154 19 avr. 2006 wjoseph $
 * -------------------------------------------------------------------------
 */
package org.objectweb.petals.binding.axis2.client;

import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.WindowConstants;
import javax.swing.border.BevelBorder;


/**
 * Dispatcher for JBI container
 * 
 * @version $Rev: 250 $ $Date: 2006-04-21 14:20:57 +0200 (ven, 21 avr 2006) $
 * @since Petals 1.0
 * @author wjoseph - EBM Websourcing
 * 
 */
public class AxisGUIClient extends javax.swing.JFrame {

    private static final long serialVersionUID = -10075363478608221L;

    private JPanel jPanel1;

    private JPanel jPanel4;

    private JScrollPane jScrollPane1;

    private JTextArea out;

    private JTextArea in;

    private JTextField operation;

    private JTextField service;

    private JTextField host;

    private JTextField port;

    private JButton jButton1;

    private JLabel jLabel2;

    private JLabel jLabel1;

    private JLabel jLabel3;

    private JLabel jLabel4;

    private JPanel jPanel2;

    public AxisGUIClient() {
        super();
        initGUI();
    }

    public static void main(String[] args) {
        AxisGUIClient inst = new AxisGUIClient();
        inst.setVisible(true);
    }

    /**
     * 
     * @param host
     *            distant host
     * @param port
     *            distant port
     * @param service
     *            distant service
     * @param operation
     *            distant operation
     * @param msg
     *            message content
     * @return Response to call
     */
    public static String send(String host, String port, String service,
            String operation, Object[] parameters) {

        /*
        String bodyNamespace = "urn:Foo";
        String encodingStyleProperty = "javax.xml.rpc.encodingstyle.namespace.uri";
        String xsdNamespace = "http://www.w3.org/2001/XMLSchema";
        String encodingUri = "http://schemas.xmlsoap.org/soap/encoding/";
*/
        String result = new String();

        try {
            /*
            ServiceFactory factory = ServiceFactory.newInstance();
            Service serviceCalled = factory.createService(new QName(service));

            QName portName = new QName(service);

            javax.xml.rpc.Call call = serviceCalled.createCall(portName);
            call.setTargetEndpointAddress("http://" + host + ":" + port + "/"
                    + service);

            call.setProperty(javax.xml.rpc.Call.SOAPACTION_USE_PROPERTY,
                    true);
            call.setProperty(javax.xml.rpc.Call.SOAPACTION_URI_PROPERTY, "");
            call.setProperty(encodingStyleProperty, encodingUri);
            QName stringTypeQname = new QName(xsdNamespace, "string");
            call.setReturnType(stringTypeQname);

            call.setOperationName(new QName(bodyNamespace, operation));
            call.addParameter(operation + "Request", stringTypeQname,
                    ParameterMode.IN);
            String[] params = new String[parameters.length];
            int i = 0;
            for (Object param : parameters) {
                params[i++] = (String) param;
            }
            result = (String) call.invoke(params);
            return result;
            */

        } catch (Exception ex) {
            ex.printStackTrace();
            return ex.toString();
        }


        /*
         String response = null;
         Call foo = new Call();
         foo.setMethodName(operation);
         foo.setTargetObjectURI("http://" + host + ":" + port + "/" + service);
         foo.setEncodingStyleURI(Constants.NS_URI_SOAP_ENC);
         if (parameters != null) {
         Vector<Parameter> params = new Vector<Parameter>();
         for (Object param : parameters) {
         params.add(new Parameter("arg", param.getClass(), param
         .toString(), null));
         }
         foo.setParams(params);
         }
         try {
         Response res = foo.invoke(new URL(foo.getTargetObjectURI()), "coucou");
         if (!res.generatedFault()) {
         response = (String) res.getReturnValue().getValue();
         } else {
         response = res.getFault().getFaultString();
         }
         } catch (MalformedURLException excurl) {
         System.out.println("The URL Exception is : " + excurl.toString());
         } catch (SOAPException soe) {
         System.out.println("The SOAP Exception is : " + soe.toString());
         }
         return response;
         */
        return result;
    }

    public void setResponse(String text) {
        out.append(text + "\n");
    }

    /**
     * Initiates the GUI
     * 
     */
    private void initGUI() {
        try {
            GridLayout thisLayout = new GridLayout(3, 1);
            thisLayout.setHgap(5);
            thisLayout.setVgap(5);
            thisLayout.setColumns(1);
            thisLayout.setRows(3);
            getContentPane().setLayout(thisLayout);
            setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
            this.setPreferredSize(new java.awt.Dimension(490, 316));
            jPanel1 = new JPanel();
            GridLayout jPanel1Layout = new GridLayout(5, 2);
            jPanel1Layout.setHgap(5);
            jPanel1Layout.setVgap(5);
            jPanel1Layout.setColumns(2);
            jPanel1Layout.setRows(5);
            jPanel1.setLayout(jPanel1Layout);
            getContentPane().add(jPanel1);
            jPanel1.setSize(500, 400);
            jPanel1.setBorder(BorderFactory
                    .createEtchedBorder(BevelBorder.LOWERED));
            jPanel1.setPreferredSize(new java.awt.Dimension(490, 400));
            jLabel1 = new JLabel();
            jPanel1.add(jLabel1);
            jLabel1.setText("service");
            jLabel1.setPreferredSize(new java.awt.Dimension(113, 39));
            service = new JTextField();
            jLabel1.add(service);
            service.setText("{http://petals.objectweb.org/}HelloworldService");
            service.setBounds(245, 0, 231, 21);
            jLabel2 = new JLabel();
            jPanel1.add(jLabel2);
            jLabel2.setText("operation");
            jLabel2.setPreferredSize(new java.awt.Dimension(132, 39));
            operation = new JTextField();
            jLabel2.add(operation);
            operation.setText("printMessage");
            operation.setBounds(245, 0, 231, 21);
            jLabel3 = new JLabel();
            jPanel1.add(jLabel3);
            jLabel3.setText("host");
            jLabel3.setPreferredSize(new java.awt.Dimension(113, 39));
            host = new JTextField();
            jLabel3.add(host);
            host.setText("127.0.0.1");
            host.setBounds(245, 0, 231, 21);
            jLabel4 = new JLabel();
            jPanel1.add(jLabel4);
            jLabel4.setText("port");
            jLabel4.setPreferredSize(new java.awt.Dimension(113, 39));
            port = new JTextField();
            jLabel4.add(port);
            port.setText("8084");
            port.setBounds(245, 0, 231, 21);
            jPanel4 = new JPanel();
            getContentPane().add(jPanel4);
            jPanel4.setBorder(BorderFactory
                    .createEtchedBorder(BevelBorder.LOWERED));
            jPanel4.setPreferredSize(new java.awt.Dimension(490, 130));
            jButton1 = new JButton();
            jPanel4.add(jButton1);
            jButton1.setText("Send request)");
            jButton1.setPreferredSize(new java.awt.Dimension(197, 39));
            jButton1.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent evt) {
                    send();
                }
            });
            jPanel2 = new JPanel();
            GridLayout jPanel2Layout = new GridLayout(1, 1);
            jPanel2Layout.setHgap(5);
            jPanel2Layout.setVgap(5);
            jPanel2Layout.setColumns(1);
            jPanel2Layout.setRows(1);
            jPanel2.setLayout(jPanel2Layout);
            getContentPane().add(jPanel2);
            jPanel2.setBorder(BorderFactory
                    .createEtchedBorder(BevelBorder.LOWERED));
            jPanel2.setSize(492, 150);
            jPanel2.setPreferredSize(new java.awt.Dimension(480, 100));
            jScrollPane1 = new JScrollPane();
            jPanel2.add(jScrollPane1);
            in = new JTextArea();
            jScrollPane1.setPreferredSize(new java.awt.Dimension(392, 200));
            jScrollPane1.setViewportView(in);
            pack();
            this.setSize(490, 316);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * Call distant operation
     * 
     */
    private void send() {

        Object[] params = {"coucou"};
        in.setText(AxisGUIClient.send(host.getText(), port.getText(), service
                .getText(), operation.getText(), params));
    }

    /* 
     public static void main(String[] args){
     try {
     
     DataSource ds = new FileDataSource("/home/wjoseph/.mailcap");
     DataSource ds2 = new FileDataSource("/home/wjoseph/.dmrc");
     DataHandler dh = new DataHandler(ds);
     DataHandler dh2 = new DataHandler(ds2);
     MimeBodyPart mimePart = new MimeBodyPart();
     MimeBodyPart mimePart2 = new MimeBodyPart();
     mimePart.setDataHandler(dh);
     mimePart2.setDataHandler(dh2);
     mimePart.setHeader(org.apache.soap.Constants.HEADER_CONTENT_LOCATION, "Attachment-1");
     mimePart2.setHeader(org.apache.soap.Constants.HEADER_CONTENT_LOCATION, "Attachment-2");
     mimePart.setContentID("001");
     mimePart2.setContentID("002");
     dh2.getContent();
     String response = null;
     Call foo = new Call();
     foo.setMethodName("coucou");
     foo.setTargetObjectURI("http://127.0.0.1:8083//foo");
     foo.setEncodingStyleURI(Constants.NS_URI_SOAP_ENC);
     foo.addBodyPart(mimePart);
     foo.addBodyPart(mimePart2);
     
     Response res = foo.invoke(new URL(foo.getTargetObjectURI()), "");
     if (!res.generatedFault()) {
     response = (String) res.getReturnValue().getValue();
     } else {
     response = res.getFault().getFaultString();
     }
     System.out.println(response);
     }catch (Exception excurl) {
     System.out.println("The URL Exception is : " + excurl.toString());
     }
     }
     */
}
