/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2006 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id: $
 * -------------------------------------------------------------------------
 */
package org.objectweb.petals.component.common.listener;

import java.util.logging.Level;
import java.util.logging.Logger;

import javax.jbi.JBIException;

import org.objectweb.petals.component.common.util.MessageExchangeWrapper;

/**
 * MessageExchange worker
 * 
 * @author Christophe DENEUX (Capgemini Sud), ofabre
 * 
 */
public class MessageExchangeWorker extends Thread {

	private MessageExchangeWrapper exchange = null;

	private MessageExchangeProcessor processor = null;

	private Logger logger = null;

	public MessageExchangeWorker(MessageExchangeWrapper exchange,
			MessageExchangeProcessor processor, Logger logger) {
		super("MessageExchangeWorker");
		this.exchange = exchange;
		this.processor = processor;
	}

	/**
	 * call the processor's process() method
	 */
	public void run() {
		if (processor != null) {
			try {
				processor.process(exchange);
			} catch (JBIException e) {
				logger.log(Level.SEVERE, e.getMessage(), e);
			}
		}
	}

}
