/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2005 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id: MockResourceBundle.java 3:07:41 PM ddesjardins $
 * -------------------------------------------------------------------------
 */
package org.objectweb.petals.component.common.util;

import java.util.Enumeration;
import java.util.ResourceBundle;

import org.easymock.classextension.EasyMock;

/**
 * Mock ResourceBundle
 * 
 * @author ddesjardins - eBMWebsourcing
 */
public class MockResourceBundle extends ResourceBundle {

    @SuppressWarnings("unchecked")
    public Enumeration<String> getKeys() {
        Enumeration keys = EasyMock.createMock(Enumeration.class);
        EasyMock.expect(keys.nextElement()).andReturn("test");
        EasyMock.expect(keys.hasMoreElements()).andReturn(true);
        EasyMock.replay(keys);
        return keys;
    }

    protected boolean handleGetObject;

    protected Object handleGetObject(String key) {
        handleGetObject = true;
        return "test msg";
    }

}
