/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2005 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * Id : FileTransferBC.java 154 ${date}  rbarraza 
 * -------------------------------------------------------------------------
 */
package org.objectweb.petals.binding.filetransferbc;

import org.objectweb.petals.binding.filetransferbc.listeners.FileTransferBCExternalListenerManager;
import org.objectweb.petals.binding.filetransferbc.listeners.FileTransferBCJBIListener;
import org.objectweb.petals.component.common.bc.AbstractBindingComponent;
import org.objectweb.petals.component.common.bc.ExternalListenerManager;

/**
 * The file transfer binding component.
 * 
 * @version $Rev: 250 $Date: {date}
 * @since Petals 1.0
 * @author alouis, Rocio BARRAZA, Christophe HAMERLING - eBM WebSourcing
 * 
 */
public class FileTransferBC extends AbstractBindingComponent {

    @Override
    protected void init(BindingComponentInitializer initializer) {
        FileTransferBCJBIListener jbiListener = new FileTransferBCJBIListener(
            getDefaultPath(), getLogger());
        ExternalListenerManager externalListenerManager = new FileTransferBCExternalListenerManager(
            getLogger(), this);

        initializer.setExternalListenerManager(externalListenerManager);
        initializer.setJbiListener(jbiListener);
    }

    /**
     * Get the default path to copy files to.
     * 
     * @return
     */
    protected String getDefaultPath() {
        String baseDir = getContext().getInstallRoot();
        StringBuffer sb = new StringBuffer(baseDir.substring(0, baseDir
            .length()
            - "install".length()));
        sb.append("FTPBC");
        return sb.toString();
    }

}
