/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2005 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id: Console.java 16:40:52 dutoo $
 * -------------------------------------------------------------------------
 */
package org.objectweb.petals.engine.sampleclient.gui;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.GridLayout;
import java.awt.Point;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ComponentEvent;
import java.awt.event.MouseAdapter;
import java.io.DataInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.List;

import javax.jbi.servicedesc.ServiceEndpoint;
import javax.swing.AbstractButton;
import javax.swing.BorderFactory;
import javax.swing.ButtonGroup;
import javax.swing.DefaultComboBoxModel;
import javax.swing.DefaultListModel;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JScrollPane;
import javax.swing.JSeparator;
import javax.swing.JTabbedPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.ListModel;
import javax.swing.ListSelectionModel;
import javax.swing.WindowConstants;
import javax.swing.border.TitledBorder;

import org.objectweb.petals.engine.sampleclient.SampleClient;
import org.objectweb.petals.engine.sampleclient.gui.model.ServiceListRenderer;

/**
 * Console of the SampleClient
 * 
 * @author alouis, ddesjardins - eBMWebsourcing
 * @author Marc Dutoo - Open Wide
 */
public class Console extends javax.swing.JFrame {
    /**
     * 
     */
    private static final long serialVersionUID = -8117896325113377153L;

    public static void main(String[] args) {
        Console inst = new Console();
        inst.setVisible(true);
        inst.setResponse("test");
    }

    private JButton asreference;

    private JPanel servicesQueryPanel;

    private JTextArea in;

    private JRadioButton inout;

    private JRadioButton inoutopt;

    private JButton jButton1;

    private JButton jButton2;

    private JButton jButton3;

    private JButton jButtonAddAttachments;
    
    private JFileChooser jFileChooserAttachment;

    private JButton jButtonRemoveAttachments;

    private JLabel jLabel1;

    private JLabel jLabel2;

    private JLabel jLabel3;

    private JLabel jLabel4;

    private JLabel jLabel8;

    private JLabel jLabel81;
    
    private DefaultListModel jListModelSelectedAttachments;
    
    private JList jListSelectedAttachments;

    private JList jList1;

    private JPanel jPanel1;

    private JPanel jPanel2;

    private JPanel jPanel3;

    private JPanel jPanel4;

    private JPanel jPanelAttachment;

    private JPanel botQueryPanel;

    private JPanel topQueryPanel;

    private JRadioButton jRadioButton1;

    private JScrollPane jScrollPane1;

    private JScrollPane jScrollPane2;

    private JScrollPane servicesScrollPanel;

    private JSeparator jSeparator1;

    private JSeparator jSeparator11;

    private JTabbedPane jTabbedPane1;  //  @jve:decl-index=0:visual-constraint="10,842"

    private JTextArea jTextArea1;

    private JTextField operation;

    private JTextArea out;

    private JPanel queryPanel;

    private JButton resolve;

    private JRadioButton robustin;

    private SampleClient sampleClient;

    private JPanel sendPanel;

    private JButton sendSync;

    private JTextField service;

    private JTextField timeout;

    private ButtonGroup typeGroup;

    private JButton jButton31;

    private JLabel background1;

    private JLabel background;

    public Console() {
        super();
        initialize();
        initGUI();
    }

    public Console(SampleClient sampleClient) {
        this();
        this.sampleClient = sampleClient;
    }

    private void getAsReference() {
        ServiceEndpoint se = (ServiceEndpoint) services[jList1
            .getSelectedIndex()];

        String msg = sampleClient.getAsReference(se);
        openDialogBox("Reference of " + se, msg);

    }

    /**
     * This method initializes jSeparator11
     * 
     * @return javax.swing.JSeparator
     */
    private JSeparator getJSeparator11() {
        if (jSeparator11 == null) {
            jSeparator11 = new JSeparator();
            jSeparator11.setBounds(new Rectangle(10, 170, 571, 11));
        }
        return jSeparator11;
    }

    private void getServices() {
        ServiceEndpoint[] se = sampleClient.getEndpoints();
        this.services = se;
        // String[] se = new String[] {"test"};
        DefaultListModel listModel = new DefaultListModel();
        jList1
            .setCellRenderer(new ServiceListRenderer(jList1.getCellRenderer()));
        for (int i = 0; i < se.length; i++) {
            String name = se[i].toString();
            JLabel label = new JLabel();
            label.setText(name);
            label.setToolTipText("Click to select in the Send Panel");
            label.addMouseListener(new ServiceSelector(name));
            listModel.addElement(label);
        }
        jList1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent e) {
                if (e.getClickCount() == 2) {
                    if (jList1.getSelectedValue() != null) {
                        JLabel label = (JLabel) jList1.getSelectedValue();
                        String name = label.getText();
                        if (name.indexOf(" ") > -1) {
                            name = name.substring(0, name.indexOf(" "));
                        }
                        service.setText(name);
                        jTabbedPane1.setSelectedIndex(0);
                    }
                }
            }
        });
        jList1.setModel(listModel);
        if (se.length > 0) {
            jList1.setSelectedIndex(0);
        }
    }

    private class ServiceSelector extends MouseAdapter {
        private String name;

        public ServiceSelector(String name) {
            this.name = name;
        }

        public void mousePressed(java.awt.event.MouseEvent e) {
            service.setText(name);
            jTabbedPane1.setSelectedIndex(0);
        }

        public void mouseClicked(java.awt.event.MouseEvent e) {
            service.setText(name);
            jTabbedPane1.setSelectedIndex(0);
        }
    }

    private void initGUI() {
        try {
            GridLayout gridLayout1 = new GridLayout();
            gridLayout1.setRows(2);
            GridLayout gridLayout = new GridLayout();
            gridLayout.setRows(2);
            setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
            {
                jTabbedPane1 = new JTabbedPane();
                getContentPane().add(jTabbedPane1);
                jTabbedPane1.setSize(592, 652);
                jTabbedPane1.setBackground(new Color(242, 237, 243));
                {
                    sendPanel = new JPanel();

                    byte[] buffer = null;
                    InputStream inStream = this.getClass().getResourceAsStream(
                        "/ebmlogo.jpg");
                    try {
                        if (inStream == null) {
                            inStream = new FileInputStream("src"
                                + File.separator + "img" + File.separator
                                + "ebmlogo.jpg");
                        }
                        DataInputStream dis = new DataInputStream(inStream);
                        buffer = new byte[dis.available()];
                        dis.readFully(buffer);
                        ImageIcon img1 = new ImageIcon(buffer);
                        background = new JLabel(img1);
                        background.setBounds(360, 540, img1.getIconWidth(),
                            img1.getIconHeight());
                        sendPanel.add(background);
                    } catch (Exception e) {
                        JOptionPane.showMessageDialog(this, e.getMessage(),
                            "Error", JOptionPane.ERROR_MESSAGE);
                    }

                    sendPanel.setLayout(null);
                    jTabbedPane1.addTab("Send", null, sendPanel, null);
                    sendPanel.setOpaque(false);
                    sendPanel.setForeground(new Color(243, 238, 243));
                    sendPanel.setBackground(new Color(242, 237, 243));

                    {
                        {
                            typeGroup = new ButtonGroup();
                        }
                        jPanel1 = new JPanel();
                        jPanel1.setBackground(new Color(242, 237, 243));
                        jPanel1.setLayout(gridLayout);
                        jPanel1.setBounds(new Rectangle(0, 0, 586, 80));
                        jPanel1.setBorder(BorderFactory
                            .createTitledBorder("Service"));
                        jPanel1.setOpaque(false);
                        {
                            jLabel1 = new JLabel();
                            jLabel1.setText("Service");
                        }
                        {
                            service = new JTextField();
                            service.setText("{http://petals.objectweb.org/}HelloworldService");
                        }
                        {
                            jLabel2 = new JLabel();
                            jLabel2.setText("Operation");
                        }
                        {
                            operation = new JTextField();
                            jPanel1.add(jLabel1, null);
                            jPanel1.add(service, null);
                            jPanel1.add(jLabel2, null);
                            jPanel1.add(operation, null);
                            operation.setText("printMessage");
                        }
                    }

                    {
                        // creating attachments panel
                        jPanelAttachment = new JPanel(new BorderLayout());
                        jPanelAttachment.setBackground(new Color(242, 237, 243));
                        jPanelAttachment.setLocation(new Point(0, 80));
                        jPanelAttachment.setSize(586, 100);
                        jPanelAttachment.setBorder(BorderFactory.createTitledBorder("Attachments"));
                        jPanelAttachment.setOpaque(false);
                        {
                            jListSelectedAttachments = new JList();
                            jListSelectedAttachments.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
                            jListModelSelectedAttachments = new DefaultListModel();
                            jListSelectedAttachments.setModel(jListModelSelectedAttachments);
                        }
                        {
                            // creating add attachment button
                            jButtonAddAttachments = new JButton();
                            jButtonAddAttachments.setText("Add attachments");
                            jButtonAddAttachments.setBounds(new Rectangle(5, 20, 196, 26));
                            jButtonAddAttachments.setPreferredSize(new java.awt.Dimension(130, 18));
                            jFileChooserAttachment = new JFileChooser();
                            jFileChooserAttachment.setMultiSelectionEnabled(true);
                            jButtonAddAttachments.addActionListener(new ActionListener() {
                                public void actionPerformed(ActionEvent e) {
                                    int res = jFileChooserAttachment.showOpenDialog(Console.this);
                                    if (res == JFileChooser.APPROVE_OPTION) {
                                        for (File attachmentFile : jFileChooserAttachment.getSelectedFiles()) {
                                            jListModelSelectedAttachments.addElement(attachmentFile);
                                        }
                                    }
                                }
                            });
                        }
                        {
                            // creating remove attachment button
                            jButtonRemoveAttachments = new JButton();
                            jButtonRemoveAttachments.setText("Remove selected");
                            jButtonRemoveAttachments.setBounds(new Rectangle(5, 20, 196, 26));
                            jButtonRemoveAttachments.setPreferredSize(new java.awt.Dimension(130, 18));
                            jButtonRemoveAttachments.addActionListener(new ActionListener() {
                                public void actionPerformed(ActionEvent e) {
                                    for (Object attachment : jListSelectedAttachments.getSelectedValues()) {
                                        jListModelSelectedAttachments.removeElement(attachment);
                                    }
                                }
                            });
                        }
                        {
                            JPanel jPanelAttachmentButtons = new JPanel(new GridLayout(1, 2));
                            jPanelAttachmentButtons.add(jButtonAddAttachments, null);
                            jPanelAttachmentButtons.add(jButtonRemoveAttachments, null);
                            jPanelAttachment.add(new JScrollPane(jListSelectedAttachments), BorderLayout.CENTER);
                            jPanelAttachment.add(jPanelAttachmentButtons, BorderLayout.SOUTH);
                        }
                    }
                    {
                        typeGroup = new ButtonGroup();
                    }
                    {
                        jPanel3 = new JPanel();
                        jPanel3.setBackground(new Color(242, 237, 243));
                        jPanel3.setLayout(gridLayout1);
                        jPanel3.setLocation(new Point(0, 180));
                        jPanel3.setSize(586, 80);
                        jPanel3.setBorder(BorderFactory
                            .createTitledBorder("Message exchange pattern"));
                        jPanel3.setOpaque(false);
                        {
                            jRadioButton1 = new JRadioButton();
                            jRadioButton1.setText("InOnly");
                            jRadioButton1.setAutoscrolls(true);
                            typeGroup.add(jRadioButton1);
                            jRadioButton1.setSelected(true);
                            jRadioButton1.setOpaque(false);
                        }
                        {
                            inout = new JRadioButton();
                            inout.setText("InOut");
                            typeGroup.add(inout);
                            inout.setOpaque(false);
                        }
                        {
                            inoutopt = new JRadioButton();
                            jPanel3.add(jRadioButton1, null);
                            inoutopt.setText("InOptionalOut");
                            typeGroup.add(inoutopt);
                            inoutopt.setOpaque(false);
                        }
                        {
                            robustin = new JRadioButton();
                            jPanel3.add(inout, null);
                            jPanel3.add(inoutopt, null);
                            jPanel3.add(robustin, null);
                            robustin.setText("RobustInOnly");
                            robustin.setOpaque(false);
                            typeGroup.add(robustin);
                        }
                    }
                    {
                        jPanel2 = new JPanel();
                        jPanel2.setLayout(null);
                        jPanel2.setSize(586, 344);
                        jPanel2.setLocation(new Point(0, 260));
                        jPanel2
                            .setPreferredSize(new java.awt.Dimension(10, 10));
                        jPanel2.setBorder(BorderFactory.createTitledBorder(
                            null, "Request / Response body",
                            TitledBorder.LEADING, TitledBorder.TOP));
                        jPanel2.setOpaque(false);
                        {
                            jLabel3 = new JLabel();
                            jLabel3.setText("In");
                            jLabel3.setBounds(new Rectangle(5, 20, 576, 20));
                        }
                        {
                            jScrollPane1 = new JScrollPane();
                            jScrollPane1
                                .setBounds(new Rectangle(5, 45, 576, 90));
                            jPanel2.add(jLabel3, null);
                            {
                                in = new JTextArea(3, 40);
                                jScrollPane1.setViewportView(in);
                                in.setLineWrap(true);
                                in.setWrapStyleWord(true);
                                in.setPreferredSize(new Dimension(573, 64));
                                in.setText("<text>hi !</text>");
                            }
                        }
                        {
                            jLabel4 = new JLabel();
                            jPanel2.add(jScrollPane1, null);
                            jLabel4.setText("Out");
                            jLabel4.setBounds(new Rectangle(5, 140, 576, 20));
                        }
                        {
                            jScrollPane2 = new JScrollPane();
                            jScrollPane2.setBounds(new Rectangle(5, 165, 576,
                                90));
                            jPanel2.add(jLabel4, null);
                            jPanel2.add(jScrollPane2, null);
                            {
                                out = new JTextArea(3, 40);
                                out.setLineWrap(true);
                                out.setWrapStyleWord(true);
                                jScrollPane2.setViewportView(out);
                            }
                        }
                    }
                    {
                        jPanel4 = new JPanel();
                        jPanel2.add(jPanel4, null);
                        sendPanel.add(jPanel1);
                        sendPanel.add(jPanelAttachment); // adding the attachments UI
                        sendPanel.add(jPanel3, null);
                        sendPanel.add(jPanel2, null);
                        jPanel4.setLayout(null);
                        jPanel4.setOpaque(false);
                        jPanel4.setBounds(new Rectangle(2, 259, 586, 99));
                        jPanel4.setBorder(BorderFactory
                            .createTitledBorder("Send"));
                        {
                            sendSync = new JButton();
                            sendSync.setText("SendSync");
                            sendSync.setBounds(new Rectangle(5, 20, 196, 26));
                            sendSync.setPreferredSize(new java.awt.Dimension(
                                130, 18));
                            sendSync.addActionListener(new ActionListener() {
                                public void actionPerformed(ActionEvent evt) {
                                    sendSync();
                                }
                            });
                        }
                        {
                            timeout = new JTextField();
                            timeout.setText("0");
                            timeout.setToolTipText("timeout, in ms");
                            timeout.setBounds(new Rectangle(209, 23, 42, 23));
                        }
                        {
                            jButton1 = new JButton();
                            jPanel4.add(sendSync, null);
                            jPanel4.add(timeout, null);
                            jPanel4.add(jButton1, null);
                            jButton1.setText("Send - Accept (block)");
                            jButton1.setBounds(new Rectangle(5, 55, 196, 27));
                            jButton1.setPreferredSize(new java.awt.Dimension(
                                152, 15));
                            jButton1.addActionListener(new ActionListener() {
                                public void actionPerformed(ActionEvent evt) {
                                    send();
                                }
                            });
                        }
                    }
                }
                {
                    queryPanel = new JPanel();
                    queryPanel.setOpaque(false);
                    jTabbedPane1.addTab("Query", null, queryPanel, null);
                    {

                        byte[] buffer = null;
                        InputStream inStream = this.getClass()
                            .getResourceAsStream("/ebmlogo.jpg");
                        try {
                            if (inStream == null) {
                                inStream = new FileInputStream("src"
                                    + File.separator + "img" + File.separator
                                    + "ebmlogo.jpg");
                            }
                            DataInputStream dis = new DataInputStream(inStream);
                            buffer = new byte[dis.available()];
                            dis.readFully(buffer);
                            ImageIcon img1 = new ImageIcon(buffer);
                            background1 = new JLabel(img1);
                            // background1.setBounds(360, 300,
                            // img1.getIconWidth(), img1.getIconHeight());

                        } catch (Exception e) {
                            JOptionPane.showMessageDialog(this, e.getMessage(),
                                "Error", JOptionPane.ERROR_MESSAGE);
                        }

                        {
                            topQueryPanel = new JPanel();
                            topQueryPanel.setLayout(null);
                            topQueryPanel.setOpaque(false);
                            // jPanel7.setBounds(new Rectangle(0, 0, 586, 271));
                            {
                                jLabel8 = new JLabel();
                                jLabel8
                                    .setText("Query the server to find endpoints");
                                jLabel8.setBounds(new Rectangle(5, 0, 241, 23));
                                jLabel8.setFont(new java.awt.Font("Tahoma", 0,
                                    14));

                                jLabel81 = new JLabel();
                                jLabel81.setText("Result : List of endpoints");
                                jLabel81.setBounds(new Rectangle(5, 180, 241,
                                    26));
                                jLabel81.setFont(new java.awt.Font("Tahoma", 0,
                                    14));
                            }
                            {
                                jButton2 = new JButton();
                                jButton2.setText("Find all the endpoints");
                                jButton2
                                    .setBounds(new Rectangle(5, 30, 181, 25));
                                jButton2
                                    .setPreferredSize(new java.awt.Dimension(
                                        123, 23));
                                jButton2
                                    .addActionListener(new ActionListener() {
                                        public void actionPerformed(
                                            ActionEvent evt) {
                                            getServices();
                                        }
                                    });
                            }
                            {
                                jSeparator1 = new JSeparator();
                                jSeparator1.setBounds(new Rectangle(5, 60, 253,
                                    8));
                            }
                            {
                                resolve = new JButton();
                                resolve
                                    .setText("Resolve following description");
                                resolve
                                    .setActionCommand("Resolve following description");
                                resolve
                                    .setBounds(new Rectangle(5, 65, 241, 25));
                                resolve.addActionListener(new ActionListener() {
                                    public void actionPerformed(ActionEvent evt) {
                                        resolveDescription();
                                    }
                                });
                            }
                            {
                                jTextArea1 = new JTextArea(6, 20);
                                topQueryPanel.add(jLabel8, null);
                                topQueryPanel.add(jButton2, null);
                                topQueryPanel.add(jSeparator1, null);
                                topQueryPanel.add(resolve, null);
                                topQueryPanel.add(jTextArea1, null);
                                jTextArea1
                                    .setText("< enter a w3c document fragment>");
                                jTextArea1.setLineWrap(true);
                                jTextArea1.setWrapStyleWord(true);
                                jTextArea1.setBounds(new Rectangle(5, 95, 576,
                                    71));
                            }
                        }

                        topQueryPanel.add(getJSeparator11(), null);
                        topQueryPanel.add(jLabel81, null);
                        ListModel jList1Model = new DefaultComboBoxModel(
                            new String[0]);
                        jList1 = new JList();

                        servicesScrollPanel = new JScrollPane();
                        servicesScrollPanel.setViewportView(jList1);
                        jList1.setModel(jList1Model);

                    }
                    {
                        botQueryPanel = new JPanel();
                        botQueryPanel.setLayout(null);
                        botQueryPanel
                            .setBorder(BorderFactory
                                .createTitledBorder("Action on the selected endpoint"));
                        botQueryPanel.setOpaque(false);
                        {
                            jButton3 = new JButton();
                            jButton3.setText("Get service description");
                            jButton3.setBounds(new Rectangle(5, 20, 251, 25));
                            jButton3.setPreferredSize(new java.awt.Dimension(
                                145, 26));
                            jButton3.addActionListener(new ActionListener() {
                                public void actionPerformed(ActionEvent evt) {
                                    showDescription();
                                }
                            });
                            jButton31 = new JButton();
                            jButton31
                                .setBounds(new Rectangle(265, 20, 231, 25));
                            jButton31.setText("Get interfaces");
                            jButton31.setPreferredSize(new Dimension(145, 26));
                            jButton31.addActionListener(new ActionListener() {
                                public void actionPerformed(ActionEvent evt) {
                                    showInterfaces();
                                }
                            });
                        }
                        {
                            asreference = new JButton();
                            botQueryPanel.add(jButton3, null);
                            botQueryPanel.add(asreference, null);
                            botQueryPanel.add(jButton31, null);
                            asreference
                                .setText("Get selected endpoint as reference");
                            asreference
                                .setBounds(new Rectangle(5, 55, 251, 25));
                            asreference.addActionListener(new ActionListener() {
                                public void actionPerformed(ActionEvent evt) {
                                    topQueryPanel.add(jLabel81, null);
                                    getAsReference();
                                }
                            });

                            if (background1 != null) {
                                background1.setBounds(new Rectangle(360, 63,
                                    background.getWidth(), background
                                        .getHeight()));
                                botQueryPanel.add(background1, null);
                            }
                        }
                    }

                    servicesQueryPanel = new JPanel(new BorderLayout());
                    servicesQueryPanel.add(servicesScrollPanel,
                        BorderLayout.CENTER);

                    // botQueryPanel.setBorder(new LineBorder(Color.BLACK, 2));
                    // test.setBorder(new LineBorder(Color.BLACK, 2));
                    // topQueryPanel.setBorder(new LineBorder(Color.BLACK, 2));

                    queryPanel.setLayout(new GridBagLayout());

                    GridBagConstraints c = new GridBagConstraints();

                    c.fill = GridBagConstraints.BOTH;
                    c.gridx = 0;
                    c.gridy = 0;
                    c.gridwidth = 3;
                    c.ipady = 207;
                    c.weighty = 0.0;
                    c.weightx = 0.0;
                    queryPanel.add(topQueryPanel, c);

                    c.fill = GridBagConstraints.BOTH;
                    c.gridx = 0;
                    c.gridy = 1;
                    c.gridwidth = 3;
                    c.ipady = 0;
                    c.ipadx = 0;
                    c.weighty = 1.0;
                    c.weightx = 1.0;
                    queryPanel.add(servicesQueryPanel, c);

                    c.fill = GridBagConstraints.BOTH;
                    c.gridx = 0;
                    c.gridy = 3;
                    c.ipady = 130;
                    c.ipadx = 500;
                    c.gridwidth = 3;
                    c.weighty = 0.0;
                    c.weightx = 0.0;
                    queryPanel.add(botQueryPanel, c);
                }
            }

            pack();
            this.setBackground(new Color(242, 237, 243));
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * This method initializes this
     * 
     */
    private void initialize() {
        this.setLayout(new BorderLayout());
        this.setTitle("Petals - Sample client");
        this.setBackground(new Color(242, 237, 243));
        this.setResizable(true);
        this.setSize(600, 699);
        lockInMinSize(this);
    }

    private static void lockInMinSize(final JFrame frame) {
        // Ensures user cannot resize frame to be smaller than frame is right
        // now.
        final int origX = frame.getSize().width;
        final int origY = frame.getSize().height;
        frame.addComponentListener(new java.awt.event.ComponentAdapter() {
            public void componentResized(ComponentEvent event) {
                int X = (frame.getWidth() < origX) ? origX : frame.getWidth();
                int Y = (frame.getHeight() < origY) ? origY : frame.getHeight();
                frame.setSize(X, Y);
            }
        });
    }

    /**
     * open a new JFrame with a textArea
     * 
     * @param title
     * @param textMsg
     */
    private void openDialogBox(String title, String textMsg) {
        JFrame f = new JFrame(title);
        JTextArea text = new JTextArea(textMsg);
        text.setLineWrap(true);
        text.setWrapStyleWord(true);
        JScrollPane sp = new JScrollPane(text);
        f.getRootPane().getContentPane().add(sp);
        f.pack();
        f.setSize(300, 300);
        f.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
        f.setVisible(true);
    }

    private void resolveDescription() {
        String fragmentDescription = jTextArea1.getText();

        ServiceEndpoint se = sampleClient
            .resolveDescription(fragmentDescription);
        DefaultListModel listModel = new DefaultListModel();
        listModel.addElement(se);
        jList1.setModel(listModel);
    }
    
    /**
     * Retrieves the selected attachment files from the UI
     * and returns them as a List
     * @return
     */
    private List<File> getAttachmentFiles() {
        ArrayList<File> attachmentFiles = new ArrayList<File>();
        Enumeration<?> attachmentEnum = jListModelSelectedAttachments.elements();
        while (attachmentEnum.hasMoreElements()) {
            Object attachment = attachmentEnum.nextElement();
            if (attachment instanceof File) {
                attachmentFiles.add((File) attachment);
            } // else silent error
        }
        return attachmentFiles;
    }

    private void send() {
        JRadioButton selected = null;
        out.setText("");
        Enumeration<AbstractButton> rbs = typeGroup.getElements();
        while (rbs.hasMoreElements()) {
            AbstractButton but = rbs.nextElement();
            if (but.isSelected()) {
                selected = (JRadioButton) but;
            }
        }

        sampleClient.send(service.getText(), operation.getText(), in.getText(),
            selected.getText(), getAttachmentFiles(), -1);
    }

    private void sendSync() {
        JRadioButton selected = null;
        out.setText("");
        Enumeration<AbstractButton> rbs = typeGroup.getElements();
        while (rbs.hasMoreElements()) {
            AbstractButton but = rbs.nextElement();
            if (but.isSelected()) {
                selected = (JRadioButton) but;
            }
        }

        sampleClient.send(service.getText(), operation.getText(), in.getText(),
            selected.getText(), getAttachmentFiles(),
            Long.parseLong(timeout.getText()));
    }

    public void setResponse(String text) {
        // out.append(text + "\n");
        out.setText(text);
    }

    private ServiceEndpoint[] services;

    private void showDescription() {
        ServiceEndpoint se = (ServiceEndpoint) services[jList1
            .getSelectedIndex()];

        String msg = sampleClient.getDescription(se);
        openDialogBox("Description of " + se, msg);
    }

    private void showInterfaces() {
        ServiceEndpoint se = (ServiceEndpoint) services[jList1
            .getSelectedIndex()];

        String msg = sampleClient.getInterfaces(se);
        openDialogBox("Interfaces of " + se, msg);
    }

    public void showError(Throwable e) {
        String error = "";
        for (StackTraceElement iterable_element : e.getStackTrace()) {
            error += iterable_element.toString() + "\n";
        }
        JOptionPane.showMessageDialog(this, error, "error",
            JOptionPane.ERROR_MESSAGE);
    }
    public void showWarning(String msg) {
        JOptionPane.showMessageDialog(this, msg, "warning",
            JOptionPane.WARNING_MESSAGE);
    }
}  //  @jve:decl-index=0:visual-constraint="10,10"
