/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2005 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id: ServiceListRenderer.java 16:40:52 ddesjardins $
 * -------------------------------------------------------------------------
 */
package org.objectweb.petals.engine.sampleclient.gui.model;

import java.awt.Component;

import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.ListCellRenderer;

/**
 * CellRenderer for the list of services
 * 
 * @author ddesjardins - eBMWebsourcing
 */
public class ServiceListRenderer implements ListCellRenderer {

    private ListCellRenderer listCellRenderer;

    public ServiceListRenderer(ListCellRenderer defaultCellRenderer) {
        this.listCellRenderer = defaultCellRenderer;
    }

    public Component getListCellRendererComponent(JList list, Object value,
        int index, boolean isSelected, boolean cellHasFocus) {
        JLabel component = (JLabel) listCellRenderer
            .getListCellRendererComponent(list, value, index, isSelected,
                cellHasFocus);
        if (value instanceof JLabel) {
            component.setText(((JLabel) value).getText());
            component.setToolTipText(((JLabel) value).getToolTipText());
        }
        return component;
    }

}
