/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2005 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id : $ 
 * -------------------------------------------------------------------------
 */

package org.objectweb.petals.binding.xquarebc;

/**
 * Dedicated exception for XQuare BC-specific errors.
 * 
 * @version $Rev: 250 $Date: {date}
 * @since Petals 1.0
 * @author Marc Dutoo - Open Wide
 * 
 */
public class XQuareBCException extends Exception {

    private static final long serialVersionUID = 1L;

    protected String messageKey;

    /**
     * @param message
     *            the raw message explaining the cause of the error
     */
    public XQuareBCException(String message) {
        super(message);
    }

    /**
     * @param message
     *            the raw message explaining the cause of the error
     * @param messageKey
     *            key matching a message to display for internationalization
     */
    public XQuareBCException(String message, String messageKey) {
        super(message);
        this.messageKey = messageKey;
    }

    /**
     * @param message
     *            the raw message explaining the cause of the error
     * @param e
     *            the exception
     */
    public XQuareBCException(String message, Throwable e) {
        super(message, e);
    }

    /**
     * @param message
     *            the raw message explaining the cause of the error
     * @param e
     *            the exception
     * @param messageKey
     *            key matching a message to display for internationalization
     */
    public XQuareBCException(String message, Throwable e,
        String messageKey) {
        super(message, e);
        this.messageKey = messageKey;
    }

    /**
     * @param e
     *            the exception
     */
    public XQuareBCException(Throwable e) {
        super(e);
    }

}
