package org.objectweb.rentacar.persistance.bo;

import java.util.HashSet;
import java.util.Set;

import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;
import org.apache.commons.lang.builder.ToStringBuilder;

/**
 * 
 * @author ofabre
 *
 */
public class CentralOfficeVO {
	
	private String centralOfficeId;
	
	private String host;
	
	private String port;
	
	private Set<String> agencies;

	public CentralOfficeVO() {
		super();
		// TODO Auto-generated constructor stub
	}

	public CentralOfficeVO(Set<String> agencies) {
		super();
		this.agencies = agencies;
	}
	
	public CentralOfficeVO(String centralOfficeId, Set<String> agencies) {
		super();
		// TODO Auto-generated constructor stub
		this.centralOfficeId = centralOfficeId;
		this.agencies = agencies;
	}

	public CentralOfficeVO(CentralOffice centralOffice) {
		super();
		this.centralOfficeId = centralOffice.getCentralOfficeId();
		Set<String> agencies = new HashSet<String>();
		for (Agency agency : centralOffice.getAgencies()) {
			agencies.add(agency.getAgencyId());
		}
		this.agencies = agencies;
		this.host = centralOffice.getHost();
		this.port = centralOffice.getPort();
	}
	
	public Set<String> getAgencies() {
		return agencies;
	}

	public void setAgencies(Set<String> agencies) {
		this.agencies = agencies;
	}

	public String getCentralOfficeId() {
		return centralOfficeId;
	}

	public void setCentralOfficeId(String centralOfficeId) {
		this.centralOfficeId = centralOfficeId;
	}

	public String getHost() {
		return host;
	}

	public void setHost(String host) {
		this.host = host;
	}

	public String getPort() {
		return port;
	}

	public void setPort(String port) {
		this.port = port;
	}

	/**
	 * @see java.lang.Object#equals(Object)
	 */
	public boolean equals(Object object) {
		if (!(object instanceof CentralOfficeVO)) {
			return false;
		}
		CentralOfficeVO rhs = (CentralOfficeVO) object;
		return new EqualsBuilder().append(this.centralOfficeId,
				rhs.centralOfficeId).append(this.host, rhs.host).append(
				this.agencies, rhs.agencies).append(this.port, rhs.port)
				.isEquals();
	}

	/**
	 * @see java.lang.Object#hashCode()
	 */
	public int hashCode() {
		return new HashCodeBuilder(-1002924675, -292380135).append(
				this.centralOfficeId).append(this.host).append(this.agencies)
				.append(this.port).toHashCode();
	}

	/**
	 * @see java.lang.Object#toString()
	 */
	public String toString() {
		return new ToStringBuilder(this).append("centralOfficeId",
				this.centralOfficeId).append("agencies", this.agencies).append(
				"host", this.host).append("port", this.port).toString();
	}
	
	

}
