package org.objectweb.rentacar.persistance.bo;

import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;
import org.apache.commons.lang.builder.ToStringBuilder;

/**
 * 
 * @author ofabre
 * 
 *
 */
public class ContactVO {
	
	// Fields
	private String contactId;
	
	private String email;
	
	private String firstName;
	
	private String lastName;
	
	private String phone;
	
	// Relations
	private AddressVO address;

	public ContactVO() {
		super();
		// TODO Auto-generated constructor stub
	}
	
	public ContactVO(AddressVO address, String email, String firstName, String lastName, String phone) {
		super();
		this.address = address;
		this.email = email;
		this.firstName = firstName;
		this.lastName = lastName;
		this.phone = phone;
	}

	public ContactVO(String contactId, AddressVO address, String email, String firstName, String lastName, String phone) {
		super();
		// TODO Auto-generated constructor stub
		this.contactId = contactId;
		this.address = address;
		this.email = email;
		this.firstName = firstName;
		this.lastName = lastName;
		this.phone = phone;
	}
	
	public ContactVO(Contact contact) {
		super();
		// TODO Auto-generated constructor stub
		this.contactId = contact.getContactId();
		this.address = new AddressVO(contact.getAddress());
		this.email = contact.getEmail();
		this.firstName = contact.getFirstName();
		this.lastName = contact.getLastName();
		this.phone = contact.getPhone();
	}

	public AddressVO getAddress() {
		return address;
	}

	public void setAddress(AddressVO address) {
		this.address = address;
	}

	/**
	 * 
	 * @return
	 */
	public String getContactId() {
		return contactId;
	}

	public void setContactId(String contactId) {
		this.contactId = contactId;
	}

	public String getEmail() {
		return email;
	}

	public void setEmail(String email) {
		this.email = email;
	}

	public String getFirstName() {
		return firstName;
	}

	public void setFirstName(String firstName) {
		this.firstName = firstName;
	}

	public String getLastName() {
		return lastName;
	}

	public void setLastName(String lastName) {
		this.lastName = lastName;
	}

	public String getPhone() {
		return phone;
	}

	public void setPhone(String phone) {
		this.phone = phone;
	}

	/**
	 * @see java.lang.Object#equals(Object)
	 */
	public boolean equals(Object object) {
		if (!(object instanceof ContactVO)) {
			return false;
		}
		ContactVO rhs = (ContactVO) object;
		return new EqualsBuilder().append(this.phone, rhs.phone).append(
				this.address, rhs.address).append(this.email, rhs.email)
				.append(this.contactId, rhs.contactId).append(this.firstName,
						rhs.firstName).append(this.lastName, rhs.lastName)
				.isEquals();
	}

	/**
	 * @see java.lang.Object#hashCode()
	 */
	public int hashCode() {
		return new HashCodeBuilder(-684648355, 551342479).append(this.phone)
				.append(this.address).append(this.email).append(this.contactId)
				.append(this.firstName).append(this.lastName).toHashCode();
	}

	/**
	 * @see java.lang.Object#toString()
	 */
	public String toString() {
		return new ToStringBuilder(this).append("phone", this.phone).append(
				"lastName", this.lastName).append("email", this.email).append(
				"contactId", this.contactId).append("address", this.address)
				.append("firstName", this.firstName).toString();
	}
	
	

}
