package org.objectweb.rentacar.persistance.bo;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.OneToOne;

import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;
import org.apache.commons.lang.builder.ToStringBuilder;
import org.hibernate.annotations.GenericGenerator;

/**
 * 
 * @author ofabre
 *
 */
@Entity
public class Partner {
	
	private String partnerId;
	
	private Contact contact;

	public Partner() {
		super();
		// TODO Auto-generated constructor stub
	}
	
	public Partner(Contact contact) {
		super();
		this.contact = contact;
	}

	public Partner(String partnerId, Contact contact) {
		super();
		// TODO Auto-generated constructor stub
		this.partnerId = partnerId;
		this.contact = contact;
	}
	
	public Partner(PartnerVO partnerVO) {
		super();
		// TODO Auto-generated constructor stub
		this.partnerId = partnerVO.getPartnerId();
		this.contact = new Contact(partnerVO.getContact());
	}

	@OneToOne(cascade={CascadeType.ALL})
	public Contact getContact() {
		return contact;
	}

	public void setContact(Contact contact) {
		this.contact = contact;
	}

	@Id	@GeneratedValue(generator = "system-uuid")
	@GenericGenerator(name="system-uuid", strategy = "uuid")
	public String getPartnerId() {
		return partnerId;
	}

	public void setPartnerId(String partnerId) {
		this.partnerId = partnerId;
	}

	/**
	 * @see java.lang.Object#equals(Object)
	 */
	public boolean equals(Object object) {
		if (!(object instanceof Partner)) {
			return false;
		}
		Partner rhs = (Partner) object;
		return new EqualsBuilder().append(this.contact, rhs.contact).append(
				this.partnerId, rhs.partnerId).isEquals();
	}

	/**
	 * @see java.lang.Object#hashCode()
	 */
	public int hashCode() {
		return new HashCodeBuilder(-1604205539, -524900141)
				.append(this.contact).append(this.partnerId).toHashCode();
	}

	/**
	 * @see java.lang.Object#toString()
	 */
	public String toString() {
		return new ToStringBuilder(this).append("partnerId", this.partnerId)
				.append("contact", this.contact).toString();
	}
	
	

}
