package org.objectweb.rentacar.persistance.dao;

import org.objectweb.rentacar.persistance.bo.Address;
import org.objectweb.rentacar.persistance.bo.Contact;

/**
 * 
 * @author ofabre
 *
 */
public class ContactDAO extends GenericDAO {
	
	private static ContactDAO theInstance;
	
	private ContactDAO(){
		
	}
	
	public static synchronized ContactDAO getInstance() {
		if (null == theInstance) {
			theInstance = new ContactDAO();
		}
		return theInstance;
	}
	
	/**
	 * Udates the contact address, deleting the old address
	 * @param contactId Id of the contact
	 * @param newAddress New address of the contact
	 * @throws DAOException 
	 */
	public void updateContactAddress(String contactId, Address newAddress) throws DAOException {
		Contact contact = null;
		
		contact = (Contact)retrieveById(Contact.class, contactId);
		
		Address oldAddress =  contact.getAddress(); 
		
		contact.setAddress(newAddress);
		
		update(contact);
		
		delete(oldAddress);
		
	}

}
