package org.objectweb.petals.demo.icare.dao.hibernate;

import java.util.Collection;

import org.objectweb.petals.demo.icare.dao.CarDao;
import org.objectweb.petals.demo.icare.model.Car;
import org.objectweb.petals.demo.icare.model.Category;
import org.objectweb.petals.demo.icare.model.Entity;
import org.objectweb.petals.demo.icare.model.Reservation;
import org.springframework.orm.hibernate3.support.HibernateDaoSupport;

/**
 * @author Cristian Spiescu
 * @author Imad Zarzouri
 * @author Omar Senhaji Rhazi
 * @author Anass Ouazzani Chahdi
 * 
 * @since 15.01.2007
 */
public class CarHibernateDao extends HibernateDaoSupport implements CarDao {

	@SuppressWarnings("unchecked")
	public Collection<Car> loadAllCars() {
		return getHibernateTemplate().find("from Car");
	}

	public void storeEntity(Entity e) {
		getHibernateTemplate().saveOrUpdate(e);
	}
	
	public Entity getEntityById(Class clazz, long id) {
		return (Entity) getHibernateTemplate().get(clazz, id);
	}

	public void storeAllCategories(Collection<Category> list) {
		getHibernateTemplate().saveOrUpdateAll(list);
	}
	
	public void storeAllCars(Collection<Car> list) {
		getHibernateTemplate().saveOrUpdateAll(list);
	}

	@SuppressWarnings("unchecked")
	public Collection<Category> loadAllCategories() {
		return getHibernateTemplate().find("from Category");
	}

	public void storeAllReservation(Collection<Reservation> list) {
		getHibernateTemplate().saveOrUpdateAll(list);
		
	}

	public Collection<Reservation> loadAllReservations() {
		return getHibernateTemplate().find("from Reservation");
	}	
}
