package org.objectweb.petals.demo.icare.model;

import java.util.Set;

/**
 * The Car entity
 * 
 * @author Cristian Spiescu
 * @author Imad Zarzouri
 * @author Omar Senhaji Rhazi
 * @author Anass Ouazzani Chahdi
 * 
 * @since 15.01.2007
 */
public class Car extends Entity {
	private Category category;
	
	private Set<Reservation> reservations;
	
	private String brand;
	
	private String model;

	public Car() {
		super();
	}

	public Car(Category category, String brand, String model) {
		super();
		this.category = category;
		this.brand = brand;
		this.model = model;
	}

	public String getBrand() {
		return brand;
	}

	public void setBrand(String brand) {
		this.brand = brand;
	}

	public Category getCategory() {
		return category;
	}

	public void setCategory(Category category) {
		this.category = category;
	}

	public String getModel() {
		return model;
	}

	public void setModel(String model) {
		this.model = model;
	}

	public Set<Reservation> getReservations() {
		return reservations;
	}

	public void setReservations(Set<Reservation> reservations) {
		this.reservations = reservations;
	}
	
	public String toString(){
		//return ("Category : "+ category + "  Brand : " + brand + "  Model : " + model);
		return ("(" + category + ") " + brand + " " + model);
	}
	
}
