package org.objectweb.petals.demo.icare.service;

import java.util.Collection;

import org.objectweb.petals.demo.icare.model.Car;
import org.objectweb.petals.demo.icare.model.Category;
import org.objectweb.petals.demo.icare.model.Reservation;
import org.objectweb.petals.demo.icare.model.dto.CarSearchDto;

/**
 * The services of the application
 * 
 * @author Cristian Spiescu
 * @author Imad Zarzouri
 * @author Omar Senhaji Rhazi
 * @author Anass Ouazzani Chahdi
 * 
 * @since 15.01.2007
 */
public interface CarService {

	Collection<Car> getAllCars();
	
	Collection<Category> getAllCategories();
	
	Collection<Reservation> getAllReservations();

	Collection<Car> getAvailableCars(CarSearchDto carSearchDto);
	
	Category findCategoryById(long id);
	
	Reservation findReservationById(long id);
	
	Car findCarById(long id);
	
	void storeCar(Car car);
	
	void storeReservation(Reservation reservation);
}
