package org.objectweb.petals.demo.icare.web;

import java.util.Map;

import javax.servlet.http.HttpServletRequest;

import org.objectweb.petals.demo.icare.model.dto.CarSearchDto;
import org.objectweb.petals.demo.icare.service.CarService;
import org.springframework.ui.ModelMap;
import org.springframework.validation.Errors;
import org.springframework.web.servlet.mvc.SimpleFormController;

/**
 * The controller for the car search form
 * 
 * @author Cristian Spiescu
 * @since 15.01.2007
 */
public class CarSearchFormController extends SimpleFormController {
    
	private CarService carService;
	
	public CarService getCarService() {
		return carService;
	}

	public void setCarService(CarService carService) {
		this.carService = carService;
	}

    protected Map referenceData(HttpServletRequest request, Object command, Errors errors) throws Exception {
        return new ModelMap("categories", carService.getAllCategories());
    }
	
	protected Object formBackingObject(HttpServletRequest request) throws Exception {
		return new CarSearchDto();
    }

    protected void doSubmitAction(Object managedResource) throws Exception {
    	CarSearchDto dto = (CarSearchDto) managedResource;
    	carService.getAvailableCars(dto);
    }

}
