package org.objectweb.petals.demo.icare.web;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.objectweb.petals.demo.icare.service.CarService;
import org.springframework.web.servlet.ModelAndView;
import org.springframework.web.servlet.mvc.AbstractController;

/**
 * @author Cristian Spiescu
 * @author Imad Zarzouri
 * @author Omar Senhaji Rhazi
 * @author Anass Ouazzani Chahdi
 *
 * @since 21.01.2007
 */
public class ReservationsListController extends AbstractController{
	private CarService carService;
	
	public CarService getCarService() {
		return carService;
	}

	public void setCarService(CarService carService) {
		this.carService = carService;
	}

	/**
	 * Shows a list with all the cars in the database
	 * 
	 * @param request
	 * @param response
	 * @return
	 * @throws ServletException
	 */
	@Override
	protected ModelAndView handleRequestInternal(HttpServletRequest arg0,
			HttpServletResponse arg1) throws Exception {
		return new ModelAndView("reservationsList", "reservations",
				getCarService().getAllReservations());
	}

}
