/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2006 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id: MortgageClient.java 154 29 juin 2006 ofabre $
 * -------------------------------------------------------------------------
 */
package org.objectweb.petals.demo.mortgage.gui;

import org.objectweb.petals.demo.mortgage.gui.gui.Console;

/**
 * Define the interface between Mortgage Gui and the Mortgage composite
 * application
 * 
 * @author ofabre - EBM Websourcing
 * 
 */
public interface MortgageClient {

    /**
     * Submit the mortgage request with customer personnal information.
     * Different WS client implementations can be used (JAXWS, AXIS2...).
     * 
     * @param firstName
     *            The first name of the customer
     * @param lastName
     *            The last name of the customer
     * @param address
     *            The address of the customer
     * @param salary
     *            The salary of the customer
     * @param propertyTaxes
     *            Property Taxes of the customer
     * @param insurrance
     *            Amount of insurrance of the customer
     * @param autoPayment
     *            All the auto payment of the customer
     * @param creditCards
     *            Amount of the credit cards of the customer
     * @param otherPayments
     *            Other payments (credits, subscriptions...) of the customer
     */
    public void submit(String firstName, String lastName, String address,
            String salary, String propertyTaxes, String insurrance,
            String autoPayment, String creditCards, String otherPayments);

    public void setConsole(Console console);
    
}
