/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2005 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id: DeliveryChannelMock.java 09:50:02 ddesjardins $
 * -------------------------------------------------------------------------
 */
package org.objectweb.petals.demo.mortgage.gui.mock;

import javax.jbi.messaging.DeliveryChannel;
import javax.jbi.messaging.MessageExchange;
import javax.jbi.messaging.MessageExchangeFactory;
import javax.jbi.messaging.MessagingException;
import javax.jbi.servicedesc.ServiceEndpoint;
import javax.xml.namespace.QName;

/**
 * Mock of DeliveryChannel
 * 
 * @author ddesjardins - eBMWebsourcing
 */
public class DeliveryChannelMock implements DeliveryChannel {

    public MessageExchange accept() throws MessagingException {
        return null;
    }

    public MessageExchange accept(long timeoutMS) throws MessagingException,
        IllegalArgumentException {
        return null;
    }

    public void close() throws MessagingException {
    }

    public MessageExchangeFactory createExchangeFactory() {
        return null;
    }

    public MessageExchangeFactory createExchangeFactory(QName interfaceName) {
        return new MessageExchangeFactoryMock();
    }

    public MessageExchangeFactory createExchangeFactory(ServiceEndpoint endpoint) {
        return null;
    }

    public MessageExchangeFactory createExchangeFactoryForService(
        QName serviceName) {
        return null;
    }

    public void send(MessageExchange exchange) throws MessagingException {
        this.exchange = exchange;
    }

    private MessageExchange exchange;

    public MessageExchange getExchange() {
        return exchange;
    }

    public boolean sendSync(MessageExchange exchange) throws MessagingException {
        return false;
    }

    public boolean sendSync(MessageExchange exchange, long timeoutMS)
        throws MessagingException {
        return false;
    }

}
