/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2006 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id: MortgageResponse.java 154 7 juin 2006 ofabre $
 * -------------------------------------------------------------------------
 */
package org.objectweb.petals.demo.mortgage.workflow.orchestration;

/**
 * Bo handling mortgage response data
 * 
 * @author ofabre - EBM Websourcing
 * 
 */
public class MortgageResponse {

    private String firstName;

    private String lastName;

    private float mortgageRate;

    public MortgageResponse() {
        super();
    }

    public MortgageResponse(String firstName, String lastName,
            float mortgageRate) {
        super();
        this.firstName = firstName;
        this.lastName = lastName;
        this.mortgageRate = mortgageRate;
    }

    public String getFirstName() {
        return firstName;
    }

    public void setFirstName(String firstName) {
        this.firstName = firstName;
    }

    public String getLastName() {
        return lastName;
    }

    public void setLastName(String lastName) {
        this.lastName = lastName;
    }

    public float getMortgageRate() {
        return mortgageRate;
    }

    public void setMortgageRate(float mortgageRate) {
        this.mortgageRate = mortgageRate;
    }

    /**
     * Overide toString to build a string from MortgageResponse fields
     * Pattern : fields separated by !!
     */
    @Override
    public String toString() {
        return firstName+"!!"+lastName+"!!"+mortgageRate;
    }
    
    

}
