/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2005 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id: NioUtilTest.java 15:30:52 ddesjardins $
 * -------------------------------------------------------------------------
 */
package org.objectweb.petals.util;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;

import junit.framework.TestCase;

/**
 * Class used to test the NioUtil class
 * 
 * @author ddesjardins - eBMWebsourcing
 */
public class NioUtilTest extends TestCase {

    /**
     * Base directory of the project
     */
    private String baseDir;

    /**
     * Set up the base directory for the test
     */
    public void setUp() {
        baseDir = this.getClass().getResource(".").toString();
        baseDir = baseDir.substring(0, baseDir.indexOf("target"));
        baseDir = baseDir.substring(baseDir.indexOf(":") + 1);
    }

    /**
     * Copy a file to another file
     * 
     * @throws IOException
     */
    public void testCopyStreamToFile() throws IOException {
        FileInputStream inputStream = new FileInputStream(baseDir + "src"
            + File.separator + "test-data" + File.separator + "fileToCopy.txt");
        NioUtil.copyStreamToFile(inputStream, new File(baseDir + "src"
            + File.separator + "test-data" + File.separator + "destFile.txt"));
    }

}
