/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2005 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id: WSDLUtilTest.java 15:45:48 ddesjardins $
 * -------------------------------------------------------------------------
 */
package org.objectweb.petals.util;

import java.io.File;
import java.io.IOException;
import java.util.List;

import javax.xml.namespace.QName;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import junit.framework.TestCase;

import org.w3c.dom.Document;
import org.xml.sax.SAXException;

/**
 * Test of the WSDLUtil
 * 
 * @author ddesjardins - eBMWebsourcing
 */
public class WSDLUtilTest extends TestCase {

    public void testAxisWSDL() throws SAXException, IOException,
        ParserConfigurationException {
        String baseDir = this.getClass().getResource(".").toString();
        baseDir = baseDir.substring(0, baseDir.indexOf("target"));
        baseDir = baseDir.substring(baseDir.indexOf(":") + 1);
        DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
        DocumentBuilder builder = factory.newDocumentBuilder();
        File xml = new File(baseDir + "src" + File.separator + "test-data"
            + File.separator + "Axis2BCService.wsdl");
        Document document = builder.parse(xml);
        QName serviceName = new QName(
            "http://org.objectweb.petals.binding.axis2bc/", "Axis2BC");
        List<QName> interfaces = WSDLUtil.getInterfacesForService(document,
            serviceName);
        assertEquals(interfaces.get(0), new QName(
            "http://org.objectweb.petals.binding.axis2bc/", "Axis2BC"));
        ;
    }

    public void testHWWSDL() throws SAXException, IOException,
        ParserConfigurationException {
        String baseDir = this.getClass().getResource(".").toString();
        baseDir = baseDir.substring(0, baseDir.indexOf("target"));
        baseDir = baseDir.substring(baseDir.indexOf(":")+1);
        DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
        DocumentBuilder builder = factory.newDocumentBuilder();
        File xml = new File(baseDir + "src" + File.separator + "test-data"
            + File.separator + "HelloworldService.wsdl");
        Document document = builder.parse(xml);
        QName serviceName = new QName(
            "http://127.0.0.1:8080/axis/Helloworld.jws", "HelloworldService");
        List<QName> interfaces = WSDLUtil.getInterfacesForService(document,
            serviceName);
        assertEquals(interfaces.get(0), new QName(
            "http://127.0.0.1:8080/axis/Helloworld.jws", "Helloworld"));
    }

}
