/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2005 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id: InstallationService.java 154 2006-03-27 15:30:10Z ofabre $
 * -------------------------------------------------------------------------
 */
package org.objectweb.petals.jbi.management.deployment;

import org.objectweb.petals.PetalsLifeCycle;

/**
 * This custom interface add methods used by redeployment tasks of the
 * SystemState service.
 * 
 * @author ofabre
 * 
 */
public interface DeploymentService extends
        javax.jbi.management.DeploymentServiceMBean, PetalsLifeCycle {

    /**
     * Returns the {@link DeploymentTaskFactory} that allows to build all
     * deployment tasks
     * 
     * @return the {@link DeploymentTaskFactory}
     */
    DeploymentTaskFactory getDeploymentTaskFactory();
}
