/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2006 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id: SharedLibraryState.java 154 28 avr. 2006 ofabre $
 * -------------------------------------------------------------------------
 */
package org.objectweb.petals.jbi.management.systemstate;

import org.objectweb.petals.util.StringHelper;

/**
 * 
 * @author Olivier Fabre, Adrien LOUIS - EBM Websourcing
 * 
 */
public class SharedLibraryState {
    private String archiveURL;

    private String installURL;

    private String name;

    public SharedLibraryState() {
        super();
    }

    public SharedLibraryState(String name, String installURL, String zipURL) {
        super();
        this.name = name;
        this.installURL = installURL;
        this.archiveURL = zipURL;
    }

    public boolean equals(Object o) {
        if (o instanceof SharedLibraryState) {
            SharedLibraryState cc = (SharedLibraryState) o;

            return StringHelper.equal(name, cc.name)
                && StringHelper.equal(installURL, cc.installURL)
                && StringHelper.equal(archiveURL, cc.archiveURL);
        } else {
            return false;
        }
    }

    public String getArchiveURL() {
        return archiveURL;
    }

    public String getInstallURL() {
        return installURL;
    }

    public String getName() {
        return name;
    }

    public int hashCode() {
        int hashCode = 0;
        if (archiveURL != null) {
            hashCode += archiveURL.hashCode();
        }
        if (installURL != null) {
            hashCode += installURL.hashCode();
        }
        if (name != null) {
            hashCode += name.hashCode();
        }
        return hashCode;
    }

    public void setArchiveURL(String zipURL) {
        this.archiveURL = zipURL;
    }

    public void setInstallURL(String installURL) {
        this.installURL = installURL;
    }

    public void setName(String name) {
        this.name = name;
    }
}
