/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2005 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id: ElectMasterThread.java 9:32:39 AM ddesjardins $
 * -------------------------------------------------------------------------
 */
package org.objectweb.petals.kernel.registry.thread;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import org.objectweb.petals.kernel.admin.ContainerInformation;
import org.objectweb.petals.kernel.registry.RegistryServer;
import org.objectweb.petals.kernel.registry.msg.request.FullUpdateRequest;
import org.objectweb.petals.kernel.registry.msg.request.RegistryRequest;
import org.objectweb.petals.util.LoggingUtil;

/**
 * ElectMasterThread
 * 
 * @author ddesjardins - eBMWebsourcing
 */
public class FullUpdateThread extends Thread {

    protected RegistryServer server;

    protected LoggingUtil log;

    protected long sender;

    public FullUpdateThread(RegistryServer server) {
        super("ElectMasterThread"
            + server.getStartTime());
        this.server = server;
        sender = server.getStartTime();
    }

    public void run() {
        log = server.getLog();
        int counter = 0;
        log.call();
        try {
            Thread.sleep(1000);
        } catch (InterruptedException e2) {
            // do nothing
        }
        if (server.getChannel().getCurrentGroup().getMembers().size() > 1) {
            RegistryRequest electRequest = new FullUpdateRequest(sender, 0);
            try {
                server.getChannel().send(electRequest);
            } catch (Exception e) {
                log.error("Problem while sending full update request", e);
            }
            counter = 0;
            while (!server.isFullyUpdated()
                && counter < 10) {
                try {
                    Thread.sleep(300);
                    counter++;
                } catch (InterruptedException e) {
                    // do nothing
                }
            }

            Map<String, Object> contMap = server.getData().get("/containers/");
            if (contMap != null) {
                List<ContainerInformation> contList = new ArrayList<ContainerInformation>();
                for (Object object : contMap.values()) {
                    contList.add((ContainerInformation) object);
                }
                server.getConfigurationService().setContainers(contList);
            }
        } else {
            server.setFullyUpdated(true);
        }
        server.getConfigurationService().setUpConfiguration();
    }

}
