/*
 * PETALS: PETALS Services Platform
 * Copyright (C) 2007 EBM WebSourcing
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA.
 *
 * Initial developer(s): Adrien LOUIS
 * --------------------------------------------------------------------------
 * $Id: 
 * --------------------------------------------------------------------------  
 */

package org.objectweb.petals.monitoring;

import java.util.List;

/**
 * @version $Rev: 617 $ $Date: 2006-06-19 17:28:41 +0200 (lun, 19 jun 2006) $
 * @since Petals 1.1
 * @author alouis
 */
public interface RouterMonitor {
    
    boolean isMonitoring();
    
    /**
     * start or stop the monitoring.
     * the monitoring information is reset when state is set to FALSE
     * @param state
     */
    void setMonitoring(boolean state);
    
    /**
     * Return the reports for all exchange since the specified date, sorted by
     * date
     * 
     * @param sinceDate
     *            date (in 'time' format)
     * @return a map of reports. not null, may be empty
     */
    List<ExchangeStateReport> getReports(long sinceDate);

}
