/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2005 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id: ComponentStateTest.java 1:52:52 PM ddesjardins $
 * -------------------------------------------------------------------------
 */
package org.objectweb.petals.jbi.management.systemstate;

import junit.framework.TestCase;

/**
 * Tests of the ComponentState
 * 
 * @author ddesjardins - eBMWebsourcing
 */
public class ComponentStateTest extends TestCase {

    public void testSettersGetters() {
        ComponentState componentState = new ComponentState();

        componentState.setArchiveURL("zipURL");
        assertEquals(componentState.getArchiveURL(), "zipURL");

        componentState.setInstallState("installed");
        assertEquals(componentState.getInstallState(), "installed");

        componentState.setInstallURL("installURL");
        assertEquals(componentState.getInstallURL(), "installURL");

        componentState.setLifecycleState("started");
        assertEquals(componentState.getLifecycleState(), "started");

        componentState.setName("name");
        assertEquals(componentState.getName(), "name");
    }

    public void testEquals() {
        ComponentState componentState = new ComponentState();
        componentState.setName("name");
        assertFalse(componentState.equals(null));
    }
}
