/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2006 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id: MockLifeCycleManagerImpl.java 154 16 mai 2006 ofabre $
 * -------------------------------------------------------------------------
 */
package org.objectweb.petals.jbi.management.systemstate;

import org.objectweb.fractal.jmx.agent.AdminAttributes;
import org.objectweb.petals.jbi.component.lifecycle.ServiceAssemblyLifeCycle;
import org.objectweb.petals.jbi.management.service.LifeCycleManagerImpl;

/**
 * Mock LifeCycleManager allowing to : set the MBeanServer returning a mock SA
 * LifeCycle
 * 
 * @author Olivier Fabre - EBM Websourcing
 * 
 */
public class MockLifeCycleManagerImpl extends LifeCycleManagerImpl {

    private ServiceAssemblyLifeCycle mockSAL;

    public MockLifeCycleManagerImpl(ServiceAssemblyLifeCycle mockSAL) {
        super();
        this.mockSAL = mockSAL;
    }

    @Override
    public ServiceAssemblyLifeCycle getServiceAssemblyByName(String saName) {
        return mockSAL;
    }

    public void setMBeanServer(AdminAttributes server) {
        this.adminAttributes = server;
    }

}
