/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2005 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id: LinkedEndpointTest.java 14:19:02 ddesjardins $
 * -------------------------------------------------------------------------
 */
package org.objectweb.petals.jbi.registry;

import javax.xml.namespace.QName;

import junit.framework.TestCase;

import org.objectweb.petals.jbi.registry.AbstractEndpoint.EndpointType;

/**
 * Test of the LinkedEndpoint
 * 
 * @author ddesjardins - eBMWebsourcing
 */
public class LinkedEndpointTest extends TestCase {

    public void testConstructor() {
        LinkedEndpoint linkedEndpoint = new LinkedEndpoint(new QName("test"),
            "endpoint", new QName("totest"), "toendpoint", null);
        assertEquals(linkedEndpoint.getToEndpointName(), "toendpoint");
        linkedEndpoint.setToServiceName(new QName("toservice"));
        assertEquals(linkedEndpoint.getToServiceName(), new QName("toservice"));
        assertEquals(linkedEndpoint.getType(), EndpointType.LINKED);
    }

    public void testConstructor1() {
        LinkedEndpoint linkedEndpoint = new LinkedEndpoint(new QName(
            "interface"), new QName("test"), "endpoint", null);
        assertEquals(linkedEndpoint.getInterfaces()[0], new QName("interface"));
        linkedEndpoint.setToEndpointName("toendpoint");
        assertEquals(linkedEndpoint.getToEndpointName(), "toendpoint");
        assertEquals(linkedEndpoint.getType(), EndpointType.LINKED);
    }
}
