/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2005 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id: MockComponentContext.java 9:34:46 AM ddesjardins $
 * -------------------------------------------------------------------------
 */
package org.objectweb.petals.jbi.routing.mock;

import org.objectweb.petals.jbi.component.context.ComponentContextImpl;
import org.objectweb.petals.jbi.messaging.DeliveryChannelImpl;
import org.objectweb.petals.jbi.registry.ConsumerEndpoint;

/**
 * Mock object of the ComponentContextImpl
 * 
 * @author ddesjardins - eBMWebsourcing
 */
public class MockComponentContext extends ComponentContextImpl {

    private MockDeliveryChannelImpl deliveryChannelImpl;

    public MockComponentContext() {
    }

    public void setDeliveryChannelImpl(
        MockDeliveryChannelImpl deliveryChannelImpl) {
        this.deliveryChannelImpl = deliveryChannelImpl;
    }

    public DeliveryChannelImpl getDeliveryChannelImpl() {
        return deliveryChannelImpl;
    }

    public ConsumerEndpoint getAddress() {
        return new ConsumerEndpoint("compo", "0");
    }

}
