/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2005 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id: MockNamingEnumeration.java 12:26:59 ddesjardins $
 * -------------------------------------------------------------------------
 */
package org.objectweb.petals.jbi.transport.mock;

import java.util.ArrayList;
import java.util.List;

import javax.naming.NamingEnumeration;
import javax.naming.NamingException;

/**
 * MockNamingEnumeration
 * 
 * @author ddesjardins - eBMWebsourcing
 */
public class MockNamingEnumeration<T> implements NamingEnumeration {

    private List<T> elems = new ArrayList<T>();

    private int pos = 0;

    public Object next() throws NamingException {
        return elems.get(pos++);
    }

    public boolean hasMore() throws NamingException {
        return pos < elems.size();
    }

    public void close() throws NamingException {
    }

    public boolean hasMoreElements() {
        return pos < elems.size();
    }

    public Object nextElement() {
        return elems.get(pos++);
    }

    public List<T> getElems() {
        return elems;
    }

    public void setElems(List<T> elems) {
        this.elems = elems;
    }

    public int getPos() {
        return pos;
    }

    public void setPos(int pos) {
        this.pos = pos;
    }

}
