/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2005 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id: JNDIConnectionTest.java 10:17:56 AM ddesjardins $
 * -------------------------------------------------------------------------
 */
package org.objectweb.petals.kernel.registry.jndi;

import java.io.IOException;

import javax.naming.NamingException;

import junit.framework.TestCase;

import org.objectweb.petals.kernel.registry.msg.request.FullUpdateRequest;
import org.objectweb.petals.kernel.registry.msg.request.PingRequest;

/**
 * JNDIConnectionTest
 * 
 * @author ddesjardins - eBMWebsourcing
 */
public class JNDIConnectionTest extends TestCase {

    public void testSend() throws NamingException, IOException,
        InterruptedException {
        int port = 8765;
        ServerSocketThread serverSocketThread = new ServerSocketThread(port,
            "127.0.0.1");
        serverSocketThread.start();
        JNDIConnection jndiConnection = new JNDIConnection(port, "127.0.0.1");
        PingRequest pingRequest = new PingRequest();
        Object out = jndiConnection.send(pingRequest);
        serverSocketThread.terminate();
        assertEquals(out, "test");
    }

    public void testSendException() throws NamingException, IOException,
        InterruptedException {
        int port = 9876;
        ServerSocketThread serverSocketThread = new ServerSocketThread(port,
            "127.0.0.1");
        serverSocketThread.start();
        JNDIConnection jndiConnection = new JNDIConnection(port, "127.0.0.1");
        FullUpdateRequest electMasterRequest = new FullUpdateRequest(0, 0);
        try {
            jndiConnection.send(electMasterRequest);
            fail();
        } catch (Exception e) {

        }
        serverSocketThread.terminate();
    }
}
