/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2005 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id: JNDINameParserTest.java 11:02:00 AM ddesjardins $
 * -------------------------------------------------------------------------
 */
package org.objectweb.petals.kernel.registry.jndi;

import javax.naming.CompositeName;
import javax.naming.InvalidNameException;
import javax.naming.NamingException;

import junit.framework.TestCase;

/**
 * Tests of the JNDINameParser
 * 
 * @author ddesjardins - eBMWebsourcing
 */
public class JNDINameParserTest extends TestCase {

    public void testParse() throws InvalidNameException, NamingException {
        JNDINameParser jndiNameParser = new JNDINameParser();
        assertEquals(jndiNameParser.parse("test"), new CompositeName("test"));
    }

    public void testEquals() {
        JNDINameParser jndiNameParser = new JNDINameParser();
        JNDINameParser jndiNameParser1 = new JNDINameParser();
        assertTrue(jndiNameParser.equals(jndiNameParser1));
    }

    public void testEquals1() {
        JNDINameParser jndiNameParser = new JNDINameParser();
        assertFalse(jndiNameParser.equals("test"));
    }

}
