/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2005 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id: NamingEnumerationImplTest.java 2:25:30 PM ddesjardins $
 * -------------------------------------------------------------------------
 */
package org.objectweb.petals.kernel.registry.jndi;

import javax.naming.NameClassPair;
import javax.naming.NamingException;

import junit.framework.TestCase;

/**
 * Test of the NamingEnumerationImpl
 * 
 * @author ddesjardins - eBMWebsourcing
 */
public class NamingEnumerationImplTest extends TestCase {

    public void testClose() throws NamingException {
        NamingEnumerationImpl<NameClassPair> names = new NamingEnumerationImpl<NameClassPair>(
            new NameClassPair[0]);
        names.close();
        assertNull(names.iterator);
    }

    public void testHasMore() throws NamingException {
        NamingEnumerationImpl<NameClassPair> names = new NamingEnumerationImpl<NameClassPair>(
            new NameClassPair[0]);
        assertFalse(names.hasMore());
        names = new NamingEnumerationImpl<NameClassPair>(new NameClassPair[1]);
        assertTrue(names.hasMore());
    }

    public void testHasMoreElements() throws NamingException {
        NamingEnumerationImpl<NameClassPair> names = new NamingEnumerationImpl<NameClassPair>(
            new NameClassPair[0]);
        assertFalse(names.hasMoreElements());
        names = new NamingEnumerationImpl<NameClassPair>(new NameClassPair[1]);
        assertTrue(names.hasMoreElements());
    }

    public void testNext() throws NamingException {
        NamingEnumerationImpl<String> names = new NamingEnumerationImpl<String>(
            new String[] {"test"});
        assertEquals(names.next(), "test");
    }
    
    public void testNextElement() throws NamingException {
        NamingEnumerationImpl<String> names = new NamingEnumerationImpl<String>(
            new String[] {"test"});
        assertEquals(names.nextElement(), "test");
    }
}
