/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2005 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id: JarURLFactoryTest.java 11:55:55 ddesjardins $
 * -------------------------------------------------------------------------
 */
package org.objectweb.petals.classloader.factory;

import java.io.File;
import java.io.IOException;
import java.net.URL;

import junit.framework.TestCase;

/**
 * Test the JarURLFactory
 * 
 * @author ddesjardins - eBMWebsourcing
 */
public class JarURLFactoryTest extends TestCase {

    private String baseDir;

    public void setUp() {
        baseDir = this.getClass().getResource(".").toString();
        baseDir = baseDir.substring(0, baseDir.indexOf("target"));
        baseDir = baseDir.substring(baseDir.indexOf(":") + 1);
    }

    public void testGetURL() throws IOException {
        JarURLFactory factory = new JarURLFactory(new URL("file:"
            + baseDir.replace(File.separator, "/")
            + "src/test-data/petals-core-test.jar"));
        URL url = factory.getURL("META-INF/MANIFEST.MF");
        assertEquals(url, new URL("jar:file:"
            + baseDir.replace(File.separator, "/")
            + "src/test-data/petals-core-test.jar!/META-INF/MANIFEST.MF"));
    }

    public void testGetURLException() throws IOException {
        URL url = new URL("file:" + baseDir.replace(File.separator, "/")
            + "src/test-data/petals-core-test.jar");
        JarURLFactory factory = new JarURLFactory(url);
        assertEquals(url, factory.getURL(""));
    }

}
