/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2005 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id: InstallationServiceMoc.java 14:21:04 ddesjardins $
 * -------------------------------------------------------------------------
 */
package org.objectweb.petals.tools.ant.util;

import javax.management.MBeanServer;
import javax.management.ObjectName;

/**
 * Moc object of the installation service
 * 
 * @author ddesjardins - eBMWebsourcing
 */
public class InstallationServiceMoc implements InstallationServiceMocMBean {

	private MBeanServer beanServer;

	public InstallationServiceMoc(MBeanServer beanServer) {
		super();
		this.beanServer = beanServer;
	}

	public String installSharedLibrary(String slZipURL) {
		return "foo003";
	}

	public ObjectName loadInstaller(String componentName) {
		return null;
	}

	public ObjectName loadNewInstaller(String installZipURL) {
		ObjectName objectName = null;
		try {
			objectName = new ObjectName("org.objectweb.petals:type=installer,name=foo001");
			beanServer.registerMBean(new InstallerMoc(beanServer), objectName);
		}
		catch (Exception e) {
			e.printStackTrace();
		}
		return objectName;
	}

	public boolean uninstallSharedLibrary(String slName) {
		return true;
	}

	public boolean unloadInstaller(String aComponentName, boolean isToBeDeleted) {
		return false;
	}

}
