/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2005-2006 EBM WebSourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id$
 * -------------------------------------------------------------------------
 */

package org.objectweb.petals.tools.jbicommon.descriptor;

import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;
import org.apache.commons.lang.builder.ToStringBuilder;

/**
 * 
 * @author ofabre
 * 
 */
public class ExtensibleJbiElement {

    private Extensions extensions;

    public ExtensibleJbiElement() { // NOPMD by gblondelle
        super();
    }

    @Override
    public boolean equals(final Object other) {
        if (!(other instanceof ExtensibleJbiElement)) {
            return false; // NOPMD by gblondelle
        }
        ExtensibleJbiElement castOther = (ExtensibleJbiElement) other;
        return new EqualsBuilder().append(extensions, castOther.extensions)
                .isEquals();
    }

    public Extensions getExtensions() {
        return extensions;
    }

    @Override
    public int hashCode() {
        return new HashCodeBuilder().append(extensions).toHashCode();
    }

    public void setExtensions(final Extensions extensions) {
        this.extensions = extensions;
    }

    @Override
    public String toString() {
        return new ToStringBuilder(this).append("extensions", extensions)
                .toString();
    }

}
