/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2005 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id: AntTaskJBI.java 09:01:14 ddesjardins $
 * -------------------------------------------------------------------------
 */
package org.objectweb.petals.tools.jbiplugin;


/**
 * This class is used to give the main configuration parameters of 
 * goals that realize a JMX action
 * 
 * @author cdeneux - Capgemini Sud
 */
public abstract class JMXTaskAbstractMojo extends JBIAbstractMojo {

	/**
     * Fail on error
     * 
     * @parameter expression="true"
     * @required
     * @description Path of the JBI sources directory
     */
    protected boolean failOnError;
    
    /**
     * Host jmx
     * 
     * @parameter expression="localhost"
     * @required
     * @description Host JMX running JBI container
     */
    protected String host;

    /**
     * Port jmx
     * 
     * @parameter expression="8081"
     * @required
     * @description Listen port of the JMX host running JBI container
     */
    protected String port;

    /**
     * User name for security
     * 
     * @parameter expression=""
     * @description JMX username to use to connect to the JBI container
     */
    protected String username = "";

    /**
     * Password for security
     * 
     * @parameter expression=""
     * @description JMX Password of the username to connect to the JBI container
     */
    protected String password;

}
