/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2005 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id: PackageAssemblyMojo.java 16:56:43 ddesjardins $
 * -------------------------------------------------------------------------
 */
package org.objectweb.petals.tools.jbiplugin;

import javax.jbi.management.LifeCycleMBean;

import org.apache.maven.plugin.MojoExecutionException;

/**
 * Shutdown a JBI Component Archive (SE or BC) previously stopped
 * 
 * @goal jbi-shutdown-component
 * @description Shutdown a JBI Component Archive (SE or BC) previously stopped
 * 
 * @author cdeneux - Capgemini Sud
 */
public class ShutdownComponentMojo extends JMXComponentAbstractMojo {

	/**
     * Execute the plugin
     */
    public void execute() throws MojoExecutionException {
        try {
        	
        	if (LifeCycleMBean.STOPPED.equals(this.getState(project
					.getArtifactId()))) {
        		this.performComponentAction(JMXComponentAbstractMojo.SHUTDOWN, project.getArtifactId());
			} else {
				System.out
						.println("The goal is skip because the component is not in the state \"" + LifeCycleMBean.STOPPED + "\".");
			}
        	
        } catch (Exception e) {
            e.printStackTrace();
            throw new MojoExecutionException(e.getLocalizedMessage(), e);
        }
    }
}
