package org.objectweb.petals.tools.petalsadmin.utils;

import java.util.Set;
import java.util.TreeSet;

import javax.management.ObjectName;

/**
 * This class represents a jbi entity
 * 
 * @author ddesjardins - eBMWebsourcing
 */
public class JBIEntity {

    /**
     * Binding component type
     */
    public static final String BINDING_COMPONENT = "Binding component";

    /**
     * Service engine type
     */
    public static final String SERVICE_ENGINE = "Service engine";

    /**
     * Service assembly type
     */
    public static final String SERVICE_ASSEMBLY = "Service assembly";

    /**
     * Name of the entity
     */
    private String name;

    /**
     * State of the entity
     */
    private String state;

    /**
     * Description of the entity
     */
    private String description;

    /**
     * JMX ObjectName
     */
    private ObjectName objectName;

    /**
     * List of service units
     */
    private Set<String> serviceUnits = new TreeSet<String>();

    /**
     * Type of entity
     */
    private String type;

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getState() {
        return state;
    }

    public void setState(String state) {
        this.state = state;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public ObjectName getObjectName() {
        return objectName;
    }

    public void setObjectName(ObjectName objectName) {
        this.objectName = objectName;
    }

    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
    }

    public Set<String> getServiceUnits() {
        return serviceUnits;
    }

    public void setServiceUnits(Set<String> serviceUnits) {
        this.serviceUnits = serviceUnits;
    }

}
